<?php

/**
 * notas_debito_reliq actions.
 *
 * @package    canon
 * @subpackage notas_debito_reliq
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class notas_debito_reliqActions extends sfQuery {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        /*
         * Manejo de errores
         */
        try {

            /*
             * variables de filtro
             */
            $id_titulo = $request['id_titulo'];

            /*
             * Obtiene las notas debito derivadas de una anulacion de proyeccion
             * Se verifica que no devolver debitos anulados o ya cancelados(NO) Incidente #12628 - 20190710
             */
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
                    
    SELECT 
    tab0.*, 
    deb.valor_total 

    FROM CA_ANUAL_ETAPA_DEB TAB0 

    join ca_debito@WEBSAFI deb on tab0.id_debito = deb.id_debito

    left join ca_vencimientos@WEBSAFI ven on ven.id_debito = deb.id_debito

    WHERE 
    tab0.id_titulo = $id_titulo  
    and id_anual_etapa is null
    and deb.estado = 1 
    --and ven.cancelado = 0
                    
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

            //ejecuta y obtiene el resultado del sql
            $records = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($records);
            $this->startRow = 0;
            $this->endRow = count($records) - 1;
            $this->status = 0;
            $this->list_data = $records;
            $this->logMessage("[CA_ANUAL_ETAPA_DEB] Consulta exitosa.");
        } catch (Exception $e) {
            $error = "[CA_ANUAL_ETAPA_DEB] ERROR: " . $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

    public function executeAdd(sfWebRequest $request) {
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */
            $whereModulo = ' ';
            if (isset($request['id_modulo'])) {
                $whereModulo = " AND tab1.id_modulo = '" . $request['id_modulo'] . "' ";
            }

            $anualEtapa = $request['id_anual_etapa'];
            $titulo = $request['id_titulo'];
            $debito = $request['id_debito'];
            $debito = explode(',', $debito);
            $secDebito = $request['sec_debito'];

            //Ticket 6291 - 20170705
            foreach ($debito as $value) {

                $deb_val = $value;

                $sql = <<<EOD
UPDATE CA_ANUAL_ETAPA_DEB
SET ID_ANUAL_ETAPA     = $anualEtapa
WHERE ID_TITULO        = $titulo
AND ID_DEBITO          = $deb_val 
EOD;

                //Insertar nuevos accesos
                CN_TABLE::executeSQL($sql);
            }


            /*
             * Obtiene los accesos para un perfil
             */
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
 
SELECT ID_ANUAL_ETAPA,
  ID_TITULO,
  ID_DEBITO,
  SEC_DEBITO
FROM CA_ANUAL_ETAPA_DEB where id_anual_etapa=$anualEtapa
            
 
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;


            //ejecuta y obtiene el resultado del sql
            $records = CN_TABLE::executeSQL($sql);

            $this->totalRows = 1;
            $this->startRow = 0;
            $this->endRow = 1;
            $this->status = 0;
            $this->list_data = $records;
            $this->logMessage("[CA_ANUAL_ETAPA_DEB-ADD] Consulta exitosa.");
        } catch (Exception $e) {


            $this->logMessage("[CA_ANUAL_ETAPA_DEB-ADD] Registro Fallido $e");
            $this->status = 1;
            $this->list_data = array();
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
